Package: SUITOR
Title: Selecting the number of mutational signatures through
        cross-validation
Version: 1.14.0
Date: 2022-05-10
Authors@R: c(person(given="DongHyuk", family="Lee", role="aut", email="dhyuklee@pusan.ac.kr"),
             person(given="Bin", family="Zhu", role="aut", email="bin.zhu@nih.gov"),
             person(given="Bill", family="Wheeler", role="cre", email="wheelerb@imsweb.com"))
Description: An unsupervised cross-validation method to select the optimal number of mutational signatures. A data set of mutational counts is split into training and validation data.Signatures are estimated in the training data and then used to predict the mutations in the validation data.
Imports: stats, utils, graphics, ggplot2, BiocParallel
Depends: R (>= 4.2.0)
License: GPL-2
biocViews: Genetics, Software, SomaticMutation
Suggests: devtools, MutationalPatterns, RUnit, BiocManager,
        BiocGenerics, BiocStyle, knitr, rmarkdown
NeedsCompilation: yes
BugReports: https://github.com/wheelerb/SUITOR/issues
VignetteBuilder: knitr
git_url: https://git.bioconductor.org/packages/SUITOR
git_branch: RELEASE_3_23
git_last_commit: ff103fd
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
Packaged: 2026-04-29 01:03:11 UTC; biocbuild
Author: DongHyuk Lee [aut],
  Bin Zhu [aut],
  Bill Wheeler [cre]
Maintainer: Bill Wheeler <wheelerb@imsweb.com>

# SUITOR: selecting the number of mutational signatures through cross-validation
<br/>

### Introduction
For the  _de novo_ mutational signature analysis, 
estimating the correct number of signatures is the crucial starting point, 
since it influences all the downstream steps, including extraction of signature profiles,
 estimation of signature activities and classification of tumors based on the andestimated activities.
 Here we present an **R** package `SUITOR`, an unsupervised cross-validation tool to select 
the optimal number of signatures. 
The two main functions are `suitor()` and `suitorExtractWH()`.

For more information please refer to the package user maunual and vignette.
<br/>

### Installation
To install from Bioconductor:
```r
  if (!requireNamespace("BiocManager", quietly = TRUE)) install.packages("BiocManager") 
  BiocManager::install("SUITOR") 
```

suitorExtractWH <- function(data, rank, op=NULL){

    data <- check_data(data)
    nr   <- nrow(data)
    nc   <- ncol(data)
    if (!is.list(op)) op <- list()
    op$min.rank <- rank
    op$max.rank <- rank
    op          <- check_op(op, nc, nr, which=2)
    ERR_MAT     <- extractWH_main(data, op)

    # Extracting W and H using the seed number
    ii             <- which.min(ERR_MAT[, 2])
    NMF_C          <- my_nmf_C(as.matrix(data), rank=rank, op=op) 
    W_C            <- NMF_C$W
    D_C            <- colSums(W_C)
    if (length(D_C) > 1) {
        D_C          <- diag(D_C)
    } else {
        dim(D_C)     <- c(1, 1) 
    }
    Wn_C           <- apply(W_C, 2, function(x) x/sum(x))
    colnames(Wn_C) <- paste0("denovo ", LETTERS[seq_len(rank)]) 
    rownames(Wn_C) <- rownames(data)
    H_C            <- NMF_C$H
    Hn_C           <- D_C %*% as.matrix(H_C)
    rownames(Hn_C) <- paste0("denovo ", LETTERS[seq_len(rank)]) 

    return(list(W=Wn_C, H=Hn_C))

}

extractWH_main <- function(input, op) {

    n <- op$n.cores
    if (n < 2) {
        ret <- extractWH_seq_C(input, op, op$parMat)
    } else {    
        tmp <- extractWH_par(input, op)

        # Combine results
        ret <- NULL
        for (i in seq_len(length(tmp))) ret <- rbind(ret, tmp[[i]])     
    }
    colnames(ret) <- c("Start", "Error")

    ret

}

extractWH_seq_C <- function(data, op, parMat) {

    seeds   <- unique(parMat[, 3])
    nseeds  <- length(seeds)
    ret     <- rep(NA, nrow(parMat))
    rank    <- op$min.rank
    nc      <- ncol(data)
    print   <- (op$print > 0) && (op$n.cores == 1)
    logdata <- log(data)
    tmp0    <- data == 0
    tmp0[is.na(tmp0)] <- FALSE
    flag0   <- any(tmp0)

    for (i in seq_len(nseeds)) {
        if (print) {
            cat("\r", paste0("start ", i))
            flush.console() 
        }
        seed        <- seeds[i]
        tmp         <- my_nmf_C(as.matrix(data), rank=rank, op=op)
        W1          <- tmp$W
        H1          <- tmp$H
        input.hat   <- W1 %*% H1
        delta_denom <- min(input.hat[input.hat != 0])/2    

        input.hat2        <- input.hat
        tmp               <- input.hat2 < delta_denom
        tmp[is.na(tmp)]   <- FALSE
        if (any(tmp)) input.hat2[tmp] <- delta_denom
        tmp <- data*(logdata - log(input.hat2))
        if (flag0) tmp[tmp0] <- 0
        tmp    <- tmp - data + input.hat
        ret[i] <- sum(tmp, na.rm=TRUE)
    }

    if (print) cat("\n")
    cbind(seeds, ret)

}

extractWH_par <- function(input, op) {

    mat  <- op$parMat
    a    <- op$parStart
    b    <- op$parEnd
    n    <- op$n.cores
    i    <- -1
 
    ret <- bplapply(seq_len(n), function(i, input, op, mat, a, b) {
                extractWH_seq_C(input, op, mat[a[i]:b[i], , drop=FALSE])
                    }, input, op, mat, a, b, 
                    BPPARAM=SnowParam(workers=n, type=op$type))

    ret
}

## ----eval=FALSE---------------------------------------------------------------
#     if (!requireNamespace("BiocManager", quietly = TRUE))
#         install.packages("BiocManager")
#     BiocManager::install("SUITOR")

## -----------------------------------------------------------------------------
library(SUITOR)

## -----------------------------------------------------------------------------
    data(SimData, package="SUITOR")
    dim(SimData)
    SimData[1:6, 1:6]

## ----table1, echo=FALSE-------------------------------------------------------
v1 <- c("min.value", "min.rank", "max.rank", "k.fold", "em.eps", "max.iter",
        "n.starts", "get.summary", "plot", "print")       
v2 <- c("Minimum value of matrix before factorizing", "Minimum rank",
        "Maximum rank", "Number of folds", "EM algorithm stopping tolerance", 
        "Maximum number of iterations in EM algorithm", 
        "Number of starting points", 
        "0 or 1 to create summary results", "0 or 1 to produce an error plot",
        "0 or 1 to print info (0=no printing)")
v3 <- c("1e-4", "1", "10", "10", "1e-5", "2000", "30", "1", "1", "1")
tab1 <- data.frame(Name=v1, Description=v2, "Default Value"=v3,
                   stringsAsFactors=FALSE, check.names=FALSE)
knitr::kable(tab1)

## -----------------------------------------------------------------------------
OP  <- list(max.rank=3, k.fold=5, n.starts=4)
set.seed(123)
re <- suitor(SimData, op=OP)
str(re)

## ----table2, echo=FALSE-------------------------------------------------------
v1 <- c("min.value", "n.starts", "print")
v2 <- c("Minimum value of matrix before factorizing", 
        "Number of starting points",
        "0 or 1 to print info (0=no printing)")
v3 <- c("1e-4", "30", "1")
tab2 <- data.frame(Name=v1, Description=v2, "Default Value"=v3,
                   stringsAsFactors=FALSE, check.names=FALSE)
knitr::kable(tab2)

## -----------------------------------------------------------------------------
re$rank
set.seed(123)
Extract <- suitorExtractWH(SimData, re$rank)
head(Extract$W)
Extract$H[,1:3]

## -----------------------------------------------------------------------------
suppressPackageStartupMessages(library(MutationalPatterns))
COSMIC <- get_known_signatures(source = "COSMIC_v3.2")
plot_96_profile(Extract$W, condensed=TRUE, ymax=0.3)
CS <- cos_sim_matrix(Extract$W, COSMIC)
CS[, 1:3]

## -----------------------------------------------------------------------------
sessionInfo()

suitor <- function(data, op=NULL) {

    data <- check_data(data)
    nr   <- nrow(data)
    nc   <- ncol(data)
    op   <- check_op(op, nc, nr)
    ret  <- suitor_main(data, op)
    if (op$get.summary) {
        ret <- getSummary(ret$all.results, nc, NR=nr)
        if (op$plot) plotErrors(ret$summary) 
    }
    ret$op <- op
    ret
}

check_data <- function(data) {

    if (!length(data)) stop("ERROR with input data")
    if (!is.matrix(data) && !is.data.frame(data)) 
        stop("ERROR: data must be a matrix or data frame")
    data <- as.matrix(data)
    if (!is.matrix(data)) stop("ERROR: data cannot be coerced to a matrix")
    if (!is.numeric(data)) stop("ERROR: data must be numeric")
    if (any(data < 0)) stop("ERROR: data must be non-negative")
    if (any(!is.finite(data))) stop("ERROR: data must be non-negative")

    data

}

check_op_valid <- function(op) {

    valid <- c("min.rank", "max.rank", "k.fold", "n.starts",
        "max.iter", "em.eps", "plot", "print",
        "kfold.vec", "min.value", "get.summary",
        "BPPARAM")
    def   <- list(1, 10, 10, 30,
        2000, 1e-5, TRUE, 1,
        NULL, 0.0001, 1,
        NULL)
    op  <- default.list(op, valid, def)
    nm  <- names(op)
    tmp <- !(nm %in% valid)
    if (any(tmp)) {
        err <- nm[tmp]
        str <- paste(err, collapse=", ", sep="")
        msg <- paste("ERROR: the option(s) ", str, " are not valid", sep="")
        stop(msg)
    }
    op

}

check_op <- function(op, nc, nr, which=1) {

    # which  1=suitor, 2=extractWH

    op <- check_op_valid(op)

    if (which == 2) {
        op$k.fold    <- 1
        op$kfold.vec <- 1
    }
    if (op$min.rank < 1) stop("ERROR with option min.rank")
    if (op$max.rank < 1) stop("ERROR with option max.rank")
    if (op$min.rank > op$max.rank) 
        stop("ERROR with option min.rank and/or max.rank")
    if ((which == 1) && (op$k.fold < 2)) stop("ERROR with option k.fold")
    if (op$n.starts < 1) stop("ERROR with option n.starts")
    if (op$max.iter < 1) stop("ERROR with option max.iter")
    if ((op$em.eps <= 0) || (op$em.eps > 1)) stop("ERROR with option em.eps")
        kvec <- op[["kfold.vec", exact=TRUE]]
    if (!length(kvec)) {
        op$kfold.vec <- seq_len(op$k.fold)
    } else {
        tmp <- !(kvec %in% seq_len(op$k.fold))
        if (any(tmp)) stop("ERROR with option kfold.vec") 
    }

    op$seeds <- seq_len(op$n.starts)

    m   <- min(nr, nc)
    msg <- paste("ERROR: option min.rank cannot exceed ", m, sep="")
    if (op$min.rank > m) stop(msg)
    op$max.rank <- min(m, op$max.rank)

    op <- set_op_par(op)
    op$algorithm <- 1

    op

}


set_op_par <- function(op) {

    rvec    <- (op$min.rank):(op$max.rank)
    n.runs  <- length(op$seeds)*length(op$kfold.vec)*length(rvec)

    bp <- op[["BPPARAM", exact=TRUE]]
    if (is.null(bp)) bp <- SerialParam()
    op$n.cores <- bpnworkers(bp)
    op$BPPARAM <- bp 
    
    if ((op$n.cores < 2) || (n.runs < 2)) {
        op$n.cores <- 1
    }
    n.cores <- op$n.cores

    mat       <- getSeqsFromList(list(op$seeds, op$kfold.vec, rvec))
    tmp       <- mat[, 1]
    mat[, 1]  <- mat[, 3]
    mat[, 3]  <- tmp
    op$parMat <- mat
    if (nrow(mat) != n.runs) stop("ERROR")
    m         <- floor(n.runs/n.cores)
    rem       <- n.runs - m*n.cores
    parStart  <- rep(NA, n.cores)
    parEnd    <- rep(NA, n.cores)
    b         <- 0
    for (i in seq_len(n.cores)) {
        a           <- b + 1
        b           <- a + m - 1
        if (rem) {
            b   <- b + 1
            rem <- rem - 1
        }
        parStart[i] <- a
        parEnd[i]   <- b
    }
    if (parEnd[n.cores] != n.runs) stop("ERROR2")
    op$parStart <- parStart
    op$parEnd   <- parEnd
    op$n.cores  <- n.cores

    op

}

get_iargs <- function(x, rank, op=NULL, rvec=NULL, startNum=0) {

    if (is.null(op)) {
        ret <- c(nrow(x), ncol(x), rank, 0, 0, rank, 0, 0, startNum)
    } else {
        ret <- c(nrow(x), ncol(x), rank, op$k.fold, 
            op$max.iter, max(rvec), op$print, length(rvec), startNum)
    }
    if (length(ret) != 9) stop("ERROR with iargs")
    ret
}

get_dargs <- function(op=NULL) {

    if (is.null(op)) {
        ret <- c(.Machine$double.eps, 0, 0)
    } else {
        ret <- c(.Machine$double.eps, op$em.eps, op$min.value)
    }
    if (length(ret) != 3) stop("ERROR with dargs")
    ret
}

my_nmf_C <- function(x, rank, op=NULL) {

    iargs <- get_iargs(x, rank)
    dargs <- get_dargs(op=op)
    nr    <- nrow(x)
    nc    <- ncol(x)
    retW  <- matrix(-1, nrow=nr, ncol=rank)
    retH  <- matrix(-1, nrow=rank, ncol=nc)

    if (length(op)) {
        minv <- op$min.value
        x    <- as.numeric(x)
        tmp  <- x < minv
        tmp[is.na(tmp)] <- FALSE
        if (any(tmp)) x[tmp] <- minv 
    }

    tmp   <- .C("C_call_nmf", as.numeric(x), as.integer(iargs), 
        as.numeric(dargs), retW=as.numeric(retW), 
        retH=as.numeric(retH), PACKAGE="SUITOR")
    retW  <- matrix(tmp$retW, nrow=nr, ncol=rank, byrow=FALSE)
    retH  <- matrix(tmp$retH, nrow=rank, ncol=nc, byrow=FALSE)
    mat   <- retW %*% retH

    list(mat=mat, W=retW, H=retH)

}

suitor_main <- function(input, op) {

    n <- op$n.cores
    if (n < 2) {
        ret <- suitor_seq_C(input, op, op$parMat)
    } else {
        tmp <- suitor_par(input, op)

        # Combine results
        nruns <- nrow(op$parMat)
        cx    <- colnames(tmp[[1]])  
        ret   <- matrix(data=NA, nrow=nruns, ncol=length(cx))
        colnames(ret) <- cx
        b <- 0  
        for (i in seq_len(length(tmp))) {
            mat <- tmp[[i]]
            a   <- b + 1
            b   <- a + nrow(mat) - 1
            if (b > nruns) stop("ERROR combining results")
            ret[a:b, ] <- mat
        }
    }

    list(all.results=ret)

}

suitor_par <- function(input, op) {

    mat  <- op$parMat
    a    <- op$parStart
    b    <- op$parEnd
    n    <- op$n.cores
    i    <- -1
    bp   <- op$BPPARAM

    ret <- bplapply(seq_len(n), function(i, input, op, mat, a, b) {
                    suitor_seq_C(input, op, mat[a[i]:b[i], , drop=FALSE])
                    }, input, op, mat, a, b, 
                    BPPARAM=bp)

    ret
}

initReturnMat <- function(n) {

    tmp           <- c("Rank", "k", "Start", "Error.Train", "Error.Test",
        "EM.niter")
    ret           <- matrix(data=NA, nrow=n, ncol=length(tmp))  
    colnames(ret) <- tmp 

    ret
}

suitor_seq_C <- function(input, op, parMat) {

    seeds       <- unique(parMat[, 3])
    nseeds      <- length(seeds)
    N           <- nrow(parMat)
    ret         <- initReturnMat(N)
    MISS        <- -9999.0e100
    MISS2       <- -9999.0e99

    b <- 0
    for (i in seq_len(nseeds)) {
        seed     <- seeds[i]
        tmp      <- parMat[, 3] == seed
        rvec     <- parMat[tmp, 1]
        kvec     <- parMat[tmp, 2]
        nk       <- length(kvec)
        iargs    <- get_iargs(input, 0, op=op, rvec=rvec, startNum=i)
        dargs    <- get_dargs(op=op)
        err1     <- as.numeric(rep(MISS, nk))
        err2     <- as.numeric(rep(MISS, nk)) 
        convVec  <- as.integer(rep(0, nk))
        niterVec <- as.integer(rep(0, nk))

        tmp  <- .C("C_call_suitor", as.numeric(input), as.integer(iargs), 
            as.numeric(dargs), as.integer(rvec), as.integer(kvec), 
            ret_train=err1, ret_test=err2, ret_conv=convVec, 
            ret_niter=niterVec, PACKAGE="SUITOR")
        err1     <- tmp$ret_train
        err2     <- tmp$ret_test
        niterVec <- tmp$ret_niter
        tmp      <- err1 < MISS2
        if (any(tmp)) err1[tmp] <- NA
        tmp  <- err2 < MISS2
        if (any(tmp)) err2[tmp] <- NA

        a           <- b + 1
        b           <- a + nk - 1
        tmp         <- a:b
        ret[tmp, 1] <- rvec
        ret[tmp, 2] <- kvec
        ret[tmp, 3] <- seed
        ret[tmp, 4] <- err1
        ret[tmp, 5] <- err2
        ret[tmp, 6] <- niterVec
    }  

    ret

}

getSummary <- function(obj, NC, NR=96) {

    M      <- NR*NC
    ranks  <- obj[, 1]
    kvec   <- obj[, 2]
    uranks <- sort(unique(ranks))
    nranks <- length(uranks)
    uk     <- sort(unique(kvec))
    Kfold  <- max(uk, na.rm=TRUE)
    nk     <- length(uk)
    train  <- obj[, 4]
    test   <- obj[, 5]
    CV.tr  <- CV.te  <- rep(NA, nranks)
    tab    <- matrix(data="", nrow=2*nranks, ncol=3+nk)
    tmp0   <- is.finite(train) & is.finite(test)
    row    <- 0
    for (i in seq_len(nranks)) {
        rank <- uranks[i]
        tmpr <- ranks == rank
        CV.1 <- rep(NA, nk)
        CV.2 <- CV.1
        for (j in seq_len(nk)) {
            k    <- uk[j]
            tmpk <- kvec == k
            tmp  <- tmpr & tmpk & tmp0
            tmp[is.na(tmp)] <- FALSE
            vec1 <- train[tmp]
            vec2 <- test[tmp]
            if (!length(vec1)) next
            arg  <- which.min(vec1)
            if (length(arg)) {
                CV.1[j] <- vec1[arg]
                CV.2[j] <- vec2[arg]
            }
        }
        CV.tr[i]   <- sum(CV.1, na.rm=TRUE)
        CV.te[i]   <- sum(CV.2, na.rm=TRUE)
        mse1       <- sqrt(CV.tr[i]/(M*(Kfold-1)))
        mse2       <- sqrt(CV.te[i]/M)
        row        <- row + 1
        tab[row, ] <- c(rank, "Train", mse1, CV.1)
        row        <- row + 1
        tab[row, ] <- c(rank, "Test", mse2, CV.2)
    }

    return(getSummary_setRetObj(tab, CV.te, uranks, obj, uk))

}

getSummary_setRetObj <- function(tab, CV.te, uranks, obj, uk) {

    cx     <- c("Rank", "Type", "MSErr", paste("fold", uk, sep=""))
    colnames(tab) <- cx
    opt.r <- NA
    tab   <- as.data.frame(tab, stringsAsFactors=FALSE)
    tmp   <- (seq_len(ncol(tab)))[-2]
    for (i in tmp) tab[, i] <- as.numeric(tab[, i])

    tmp  <- is.finite(CV.te)
    vec1 <- CV.te[tmp]
    vec2 <- uranks[tmp]
    if (length(vec1)) {
        j     <- which.min(vec1)
        opt.r <- vec2[j]
    }

    list(rank=opt.r, summary=tab, all.results=obj)

}

plotErrors <- function(x) {

    errors <- as.numeric(x$MSErr)
    ranks  <- as.numeric(x$Rank)
    types  <- x$Type

    tmp     <- types %in% "Test"
    idx.min <- which.min(errors[tmp])
    x.p     <- ranks[tmp][idx.min]
    y.p     <- errors[tmp][idx.min]

    tmp <- ggplot(data=x, aes(x=ranks, y=errors, group=types)) +
        geom_line(aes(color=types),size=1)+
        scale_x_continuous(breaks=seq(1, 15, 1),name="Number of signatures")+
        scale_y_continuous(name="Prediction error")+
        scale_colour_manual(name  ="",
            breaks=c("Test", "Train"),
            labels=c("Validation", "Training"),
            values=c("red", "blue"))+
        geom_point(aes(x=x.p, y=y.p), colour="red")+  
        theme_bw()+
        theme(legend.position="bottom")

    print(tmp)

    NULL

}

# Function to assign a default value to an element in a list
default.list <- function(inList, names, default) {

    # inList      List
    # names       Vector of names of items in inList
    # default     List of default values to assign if a name is not found
    #             The order of default must be the same as in names.

    n1 <- length(names)
    n2 <- length(default)
    if (n1 != n2) stop("ERROR: in calling default.list")

    if (is.null(inList)) inList <- list()

    listNames <- names(inList)
    for (i in seq_len(n1)) {
        if (!(names[i] %in% listNames)) {
            inList[[names[i]]] <- default[[i]]   
        }
    }

    inList

} # END: default.list

getSeqsFromList <- function(inlist) {

    ncomb <- 1
    nc    <- length(inlist)
    for (i in seq_len(nc)) ncomb <- ncomb*length(inlist[[i]])
    nn    <- names(inlist)

    mat <- matrix(NA, nrow=ncomb, ncol=nc)
    if (length(nn)) colnames(mat) <- nn
    for (j in seq_len(nc)) {
        vec  <- inlist[[j]]
        nvec <- length(vec)
        if (j == 1) {
            m <- ncomb/nvec
        } else {
            m <- m/nvec
        }
        mat[, j] <- rep(vec, each=m)
    }

    mat

}

removeWhiteSpace <- function(str, leading=1, trailing=1) {

    if ((leading) && (trailing)) {
        ret <- gsub("^\\s+|\\s+$", "", str, perl=TRUE)
    } else if (leading) {
        ret <- gsub("^\\s+", "", str, perl=TRUE)
    } else if (trailing) {
        ret <- gsub("\\s+$", "", str, perl=TRUE)
    } else {
        ret <- str
    }

    ret

} # END: removeWhiteSpace

test_factor <- function() {

  set.seed(10, kind="Mersenne-Twister", normal.kind="Inversion")

  x    <- matrix(1:6, nrow=2, ncol=3, byrow=FALSE)
  m1   <- matrix(c(1.285714, 3, 4.714286, 1.714286, 4, 6.285714), nrow=2, byrow=TRUE)
  W1   <- matrix(c(2.093777, 2.791703), nrow=2)
  H1   <- matrix(c(0.6140645, 1.432817, 2.25157), nrow=1)
  m2   <- matrix(1:6, nrow=2, byrow=FALSE)
  W2   <- matrix(c(1.637889, 1.509121, 1.452761, 3.624534), nrow=2, byrow=TRUE)
  H2   <- matrix(c(0.1619284, 1.2918984, 2.4218684, 0.4868920, 0.5857803, 0.6846686), nrow=2, byrow=TRUE)

  res1 <- SUITOR:::my_nmf_C(x, 1)
  res2 <- SUITOR:::my_nmf_C(x, 2)

  checkEqualsNumeric(m1, res1$mat, tolerance=1.0e-4)
  checkEqualsNumeric(W1, res1$W,   tolerance=1.0e-4)
  checkEqualsNumeric(H1, res1$H,   tolerance=1.0e-4)
  checkEqualsNumeric(m2, res2$mat, tolerance=1.0e-4)
  checkEqualsNumeric(W2, res2$W,   tolerance=1.0e-4)
  checkEqualsNumeric(H2, res2$H,   tolerance=1.0e-4)

}

test_summary <- function() {

  ranks  <- 5:8
  kvec   <- 1:10
  nranks <- length(ranks) 
  nk     <- length(kvec)
  N      <- nranks*nk
  v1     <- rep(ranks, each=nk)
  v2     <- rep(kvec, times=nranks)
  v3     <- 100 + 1/(1:N)
  v4     <- 100 - 1/(1:N)
  x      <- cbind(v1, v2, 999, v3, v4)

  obj    <- getSummary(x, 300, NR=96)

  checkEquals(obj$rank, 5)
  
}

---
title: "SUITOR: selecting the number of mutational signatures"
author: "DongHyuk Lee and Bin Zhu"
output:
    BiocStyle::pdf_document
vignette: >
    %\VignetteIndexEntry{SUITOR: selecting the number of mutational signatures}
    %\VignetteEngine{knitr::rmarkdown}
    %\VignetteEncoding{UTF-8}
---

# Introduction
Mutational signatures are patterns of somatic mutations imprinted on the
cancer genome by operative mutational processes, and have been proposed 
to identify cancer predisposition genes and to stratify cancer patients 
for precision treatment. For the *de novo* mutational signature 
analysis, estimating the correct number of signatures is the crucial 
starting point, since it influences all the downstream steps, including 
extraction of signature profiles, estimation of signature activities and 
classification of tumors based on the estimated activities. 
Despite the many algorithms proposed to extract signature profiles and to 
estimate signature contributions, relatively little emphasis has been 
placed on selecting the correct number of de novo mutational signatures
in cancer genomics studies.
The SUITOR package uses unsupervised cross-validation to select the optimal
number of signatures.

# Installing the SUITOR package from Bioconductor
```{r, eval=FALSE}
    if (!requireNamespace("BiocManager", quietly = TRUE)) 
        install.packages("BiocManager") 
    BiocManager::install("SUITOR") 
```

# Loading the package
Before using the SUITOR package, it must be loaded into an R session.
```{r}
library(SUITOR)
```

# Example data
For illustrative purposes, we simulated a 96 by 300 mutational catalog
matrix which contains 300 tumors with respect to 96 single base substitution 
categories. Each element of the matrix is generated from the Poisson 
distribution with the mean corresponding to each element 
of `WH`, where `W` is the true signature matrix of size 96 by 8 for 8 
signatures, and `H` is the activity matrix of size 8 by 300.
Specifically for `W`, we used the profile of eight COSMIC signatures 
4, 6, 7a, 9, 17b, 22, 26, 39 from
[**COSMIC**](https://cancer.sanger.ac.uk/cosmic/signatures/SBS).
`H` is generated from a uniform distribution
between 0 and 100 with some randomly chosen elements of `H` set to 0 in order
to mimic real data.
```{r}
    data(SimData, package="SUITOR")
    dim(SimData)
    SimData[1:6, 1:6]
```

# Selecting the number of mutational signatures
The main function `suitor(data, op)` is to select the number of mutational
signatures based on cross-validation. It has two arguments described below.

## Input data
The first argument of the function `suitor()` is `data`. It could be an R 
data frame or matrix containing a mutational catalog whose elements are 
non-negative counts.
Each column of `data` corresponds to a tumor (or sample) while its rows 
represent a mutation type. Although selection of the number of signatures 
is independent to the order of mutation type, we specify the order of 
mutation type according to the 
[**COSMIC database**](https://cancer.sanger.ac.uk/signatures/sbs/) 
for extracting signature profiles using `suitorExtractWH()` after
estimating the optimal rank.

## Options
Since SUITOR is based on cross-validation and the Expectation Conditional
Maximization (ECM) algorithm, it is necessary to set a list of tuning 
parameters which control the fitting process. These parameters are defined
in the table below.

```{r table1, echo=FALSE}
v1 <- c("min.value", "min.rank", "max.rank", "k.fold", "em.eps", "max.iter",
        "n.starts", "get.summary", "plot", "print")       
v2 <- c("Minimum value of matrix before factorizing", "Minimum rank",
        "Maximum rank", "Number of folds", "EM algorithm stopping tolerance", 
        "Maximum number of iterations in EM algorithm", 
        "Number of starting points", 
        "0 or 1 to create summary results", "0 or 1 to produce an error plot",
        "0 or 1 to print info (0=no printing)")
v3 <- c("1e-4", "1", "10", "10", "1e-5", "2000", "30", "1", "1", "1")
tab1 <- data.frame(Name=v1, Description=v2, "Default Value"=v3,
                   stringsAsFactors=FALSE, check.names=FALSE)
knitr::kable(tab1)
```

The option `min.value` is a small number added to the data matrix for stable 
computation of non-negative matrix factorization. For a given number of 
signatures or ranks `rnk (min.rank <= rnk <= max.rank)`, the data matrix is 
divided into `k.fold` parts for the cross-validation. The default value of 
the maximal rank `max.rank` is 10 but it can be changed depending on the 
cancer type. The default value of the number of folds K (`k.fold`) is 10 and 
it can be modified depending on the computer resources.
Since the ECM algorithm may converge to a local saddle point, 
SUITOR tries multiple initial values for `W` and `H`. 
For this purpose, the number of starts (`n.starts`) is used. 
Although the default `n.starts` is set to 30, it can be increased
depending on the size of the data matrix and/or computational resources.
For the ECM algorithm, the default value of the maximal iteration `max.iter`
is set to 2000. It is possible for some cases to reach the maximal iteration,
for which the function would produce a warning message. Overall, we 
recommend a two-stage approach where the user would run `suitor()` with the 
default option first and then narrow down the set of plausible ranks 
(`min.rank <= rnk <= max.rank`) with more starts (`n.starts`) and a larger 
number of maximal iteration (`max.iter`) if necessary.


# Running suitor() 
By default, the `suitor()` function returns a
list containing the estimated optimal rank (`re$rank`), a summary matrix
(`re$summary`) where cross validation errors are tabulated, as well as 
the detailed results (`re$all.results`) which contain the training and 
testing errors, the total number of ECM updates, and options (`re$op`) 
used by the `suitor()` function. In addition to the estimated optimal rank 
provided by `re$rank`, a cross validation error plot is created by default.

```{r}
OP  <- list(max.rank=3, k.fold=5, n.starts=4)
set.seed(123)
re <- suitor(SimData, op=OP)
str(re)
```

# Extracting the signature profiles and activities
Once the optimal number of signatures or called rank is estimated by 
`suitor()`, we can extract the signature profiles `W` and activities
`H` with the function `suitorExtractWH(data, rank, op)`. 
As in the `suitor()` function, the input data is a data frame or matrix 
containing a mutational catalog whose elements are non-negative counts. 
A non-negative integer rank is the number of mutational signatures to be 
extracted. The possible option values are summarized in the
following table and they can be used in the same manner as `suitor()`.

```{r table2, echo=FALSE}
v1 <- c("min.value", "n.starts", "print")
v2 <- c("Minimum value of matrix before factorizing", 
        "Number of starting points",
        "0 or 1 to print info (0=no printing)")
v3 <- c("1e-4", "30", "1")
tab2 <- data.frame(Name=v1, Description=v2, "Default Value"=v3,
                   stringsAsFactors=FALSE, check.names=FALSE)
knitr::kable(tab2)
```


```{r}
re$rank
set.seed(123)
Extract <- suitorExtractWH(SimData, re$rank)
head(Extract$W)
Extract$H[,1:3]
```

`Extract$W` and `Extract$H` are estimated matrices for the profile `W`
and the activity `H`, respectively.

# Summarizing signature profiles with MutationalPatterns
The R package MutationalPatterns (Blokzijl et al., 2021) provides some utility
functions to summarize signature profiles and contains matrices of pre-defined
signatures like COSMIC. The function `plot_96_profile()` can draw 
the signature profile plot with respect to the 96 trinucleotide categories.
In addition, the function `cos_sim_matrix()` computes the cosine similarity 
between two profiles.
```{r}
suppressPackageStartupMessages(library(MutationalPatterns))
COSMIC <- get_known_signatures(source = "COSMIC_v3.2")
plot_96_profile(Extract$W, condensed=TRUE, ymax=0.3)
CS <- cos_sim_matrix(Extract$W, COSMIC)
CS[, 1:3]
```

# Session Information
```{r}
sessionInfo()
```

% --- Source file: plotData.Rd ---
\name{plotData}
\alias{plotData}
\alias{plotData}

\title{
    Example data for plotting
}
\description{
    A data frame with columns Rank, Type, and MSErr
}
%\details{}
\examples{

    data(plotData, package="SUITOR")

    plotData

}
\keyword{data}
\seealso{ \code{\link{suitor}} }

\name{getSummary}
\alias{getSummary}
\title{Compute summary results}
\description{
    Compute summary results and the optimal rank from the matrix 
    containing all results.                        
}
\usage{ getSummary(obj, NC, NR=96)
}
\arguments{
    \item{obj}{Matrix containing all results in the return list from 
        \code{\link{suitor}}.}
    \item{NC}{The number of columns in \code{data} when \code{\link{suitor}}
        was called.}
    \item{NR}{The number of rows in \code{data} when \code{\link{suitor}} 
        was called. The default is 96.}
}
\details{
    The input matrix \code{obj} must have column 1 as the rank, column 2 as 
    the value of  \code{k} in \code{1:k.fold}, column 4 as the training errors, 
    and column 5 as the testing errors.
}
\value{ A list containing the objects:
    \itemize{
    \item \code{rank}: The optimal rank
    \item \code{all.results}: Matrix containing training and testing errors 
        for all values of seeds, ranks, folds. 
        NA values appear for runs in which the EM 
        algorithm did not converge.
    \item{summary}: Data frame of summarized results for each possible rank 
        created from \code{all.results}.
        The \code{MSErr} column is defined as
        sqrt(\{fold1 + ... +foldK\}/\{nrow(data)*ncol(data)\})
    }
}
%\references{}
\author{
Donghyuk Lee <dhyuklee@pusan.ac.kr> and Bin Zhu <bin.zhu@nih.gov>
}
\examples{
    data(SimData, package="SUITOR")
    data(results, package="SUITOR")
    ret <- getSummary(results$all.results, ncol(SimData))
    ret$summary
    ret$rank
}
\keyword{ NMF, cross-validation, mutational signatures } 
\seealso{ \code{\link{plotErrors}} }

% --- Source file: data.Rd ---
\name{SimData}
\alias{SimData}
\alias{SimData}

\title{
    Data for examples
}
\description{
    Example input data and results
}
\details{ 
Contains an example input data object of size 96 by 300. 
It is generated by \code{rpois} with mean WH where W (96 by 8) is profile 
of 8 signatures (SBS 4, 6, 7a, 9, 17b, 22, 26, 39) obtained from 
https://cancer.sanger.ac.uk/cosmic/signatures/SBS and H (8 by 300) is 
rounded integer generated from a uniform distribution between 0 and 100 
with some randomly selected cells being set to zero.
}
\examples{

    data(SimData, package="SUITOR")

    # Display a subset of data objects
    SimData[1:5, 1:5]

}
\keyword{data}
\seealso{ \code{\link{suitor}} }

\name{suitorExtractWH}
\alias{suitorExtractWH}
\title{suitorExtractWH}
\description{
    Extract the matrix of activities (exposures) and matrix of signatures
}
\usage{ suitorExtractWH(data, rank, op=NULL)
}
\arguments{
    \item{data}{Data frame or matrix containing mutational signatures.
        This object must contain non-negative values}
    \item{rank}{Integer > 0}
    \item{op}{List of options (see details). The default is NULL.}
}
\details{
    \bold{Options list op:}
    \tabular{lll}{
    \bold{Name} \tab \bold{Description} \tab \bold{Default Value} \cr
    min.value   \tab Minimum value of matrix before factorizing \tab 1e-4 \cr
    BPPARAM    \tab See \code{\link[BiocParallel]{BiocParallelParam}} 
    \tab NULL \cr
    n.starts    \tab Number of starting points     \tab 30            \cr
    print       \tab 0 or 1 to print info         \tab 1             \cr       
    }

    \bold{Parallel computing} \cr
    The \code{BiocParallel} package is used for parallel computing.
    If \code{BPPARAM = NULL}, then \code{BPPARAM} 
    will be set to \code{\link[BiocParallel]{SerialParam}}. \cr

}
\value{ A list containing the objects:
    \itemize{
    \item \code{H}: Matrix of activities (exposures)
    \item \code{W}: Matrix of signatures
    }
}
%\references{}
\author{
Donghyuk Lee <dhyuklee@pusan.ac.kr> and Bin Zhu <bin.zhu@nih.gov>
}
\examples{
    data(SimData, package="SUITOR")

    suitorExtractWH(SimData, 2)
}
\keyword{ NMF, cross-validation, mutational signatures } 
\seealso{ \code{\link{suitor}} }

% --- Source file: results.Rd ---
\name{results}
\alias{results}
\alias{results}

\title{
    suitor return object
}
\description{
    An object returned from the suitor function for examples
}
%\details{ }
\examples{

    data(results, package="SUITOR")

    results

}
\keyword{data}
\seealso{ \code{\link{suitor}} }

\name{suitor}
\alias{suitor}
\title{suitor}
\description{
    Selecting the number of mutational signatures through cross-validation
}
\usage{ suitor(data, op=NULL)
}
\arguments{
    \item{data}{Data frame or matrix containing mutational signatures.
        This object must contain non-negative values}
    \item{op}{List of options (see details). The default is NULL.}
}
\details{
    The algorithm finds the optimal rank by applying k-fold cross validation.

    \bold{Options list op:}
    \tabular{lll}{
    \bold{Name} \tab \bold{Description} \tab \bold{Default Value} \cr
    em.eps      \tab EM algorithm stopping tolerance \tab 1e-5          \cr
    get.summary \tab 0 or 1 to create summary results \tab 1             \cr  
    k.fold      \tab Number of folds \tab 10            \cr  
    max.iter    \tab Maximum number of iterations in EM algorithm \tab 2000 \cr
    max.rank    \tab Maximum rank \tab 10            \cr
    min.rank    \tab Minimum rank \tab 1             \cr
    min.value   \tab Minimum value of matrix before factorizing \tab 1e-4 \cr
    BPPARAM     \tab See \code{\link[BiocParallel]{BiocParallelParam}} 
    \tab NULL \cr
    n.starts    \tab Number of starting points \tab 30            \cr
    plot        \tab 0 or 1 to produce an error plot \tab 1 \cr
    print       \tab 0 or 1 to print info \tab 1 \cr 
    kfold.vec   \tab Vector of values in 1:k.fold when running on a cluster
        \tab NULL
    }

    \bold{Parallel computing} \cr
    The \code{BiocParallel} package is used for parallel computing.
    If \code{BPPARAM = NULL}, then \code{BPPARAM} 
    will be set to \code{\link[BiocParallel]{SerialParam}}. \cr
    
    \bold{Utilizing a cluster} \cr
    When running on a cluster, the option \code{get.summary} should be set 
    to 0.
    For fastest running jobs, set the options \code{min.rank = max.rank},
    \code{kfold.vec} to a single integer in \code{1:k.fold}, and \code{n.starts}
        to 1.
}
\value{ A list containing the objects:
    \itemize{
    \item \code{rank}: The optimal rank
    \item \code{all.results}: Matrix containing training and testing errors 
        for all values of seeds, ranks, folds.
    \item{summary}: Data frame of summarized results for each possible rank 
        created from \code{all.results}.
        The \code{MSErr} column is defined as
        sqrt(\{fold1 + ... +foldK\}/\{nrow(data)*ncol(data)\})
    }
}
%\references{}
\author{
Donghyuk Lee <dhyuklee@pusan.ac.kr> and Bin Zhu <bin.zhu@nih.gov>
}
\examples{
    data(SimData, package="SUITOR")

    # Using the default options will take several minutes to run
    \donttest{ret <- suitor(SimData)}
}
\keyword{ NMF, cross-validation, mutational signatures } 
\seealso{ \code{\link{getSummary}}, \code{\link{plotErrors}} }

\name{plotErrors}
\alias{plotErrors}
\title{Plot train and test errors}
\description{
    Plot train and test errors                       
}
\usage{ plotErrors(x)
}
\arguments{
    \item{x}{Data frame of \code{summary} results in the return list from 
        \code{\link{suitor}} or from \code{\link{getSummary}}, or
        a data frame with columns \code{Rank}, \code{Type}, and 
        \code{MSErr}.}
}
\details{
    The optimal rank is the minimum at which the test error is attained, 
    and appears as a red dot on the graph.
}
\value{ NULL }
%\references{}
\author{
Donghyuk Lee <dhyuklee@pusan.ac.kr> and Bin Zhu <bin.zhu@nih.gov>
}
\examples{
    data(plotData, package="SUITOR")
    plotErrors(plotData)
}
\keyword{ NMF, cross-validation, mutational signatures } 
%\seealso{ \code{\link{getSummary}} }

\name{SUITOR-package}
\alias{SUITOR}
\docType{package}
\title{
    Number of mutational signatures
}
\description{
    To select the number of mutational signatures through cross-validation.
}
\details{
SUITOR (Selecting the nUmber of mutatIonal signaTures thrOugh 
cRoss-validation), 
an unsupervised cross-validation method that requires little assumptions and 
no numerical approximations to select the optimal number of signatures 
without overfitting the data. 
The full dataset of mutation counts is split into a training set and a 
validation set; for a given number of signatures, these signatures are 
estimated in the training set and then they are used to predict the 
mutations in the validation set. Multiple candidate numbers of signatures 
are considered; and the number of signatures which predicts most closely 
the mutations in the validation set is selected.

The two main functions in this package are \code{\link{suitor}} and 
\code{\link{suitorExtractWH}}.
}
\references{
Lee, D., Wang, D., Yang, X., Shi, J., Landi, M., Zhu, B. (2021) 
SUITOR: selecting the number of mutational signatures through cross-validation.
bioRxiv, doi: https://doi.org/10.1101/2021.07.28.454269. 
}
\author{Donghyuk Lee <dhyuklee@pusan.ac.kr> and Bin Zhu <bin.zhu@nih.gov>}
\keyword{package}
